#include <iostream>
#include <fstream>
using namespace std;

typedef unsigned long ul;
typedef unsigned int ui;

struct Bank {
    ul c5, c10, c20, c50;
    Bank() {c5 = c10 = c20 = c50 = 0;}
    Bank(Bank *b) {c5 = b->c5; c10 = b->c10; c20 = b->c20; c50 = b->c50; }
    Bank modified(int c) {
        Bank b(this);
        switch(c) {
        case 0:
        case 5:
            b.c5--; break;
        case 1:
        case 10:
            b.c10--; break;
        case 2:
        case 20:
            b.c20--; break;
        case 3:
        case 50:
            b.c50--; break;
        }
        return b;
    }
    bool add(int c) {
        switch(c) {
        case 0:
        case 5:
            c5++; break;
        case 1:
        case 10:
            c10++; break;
        case 2:
        case 20:
            c20++; break;
        case 3:
        case 50:
            c50++; break;
        }
        return true;
    }
};

Bank used;
ul u_sum=0;

bool f(Bank b, ul c_sum, ul price) {
    if (price == 0) return true;
    if (c_sum < price) return false;

    if (used.add(50) && b.c50 > 0 && (price >= 50) && f(b.modified(50), c_sum-50, price-50)) {
        return true;
    }
    used.c50--;
    if (used.add(20) && b.c20 > 0 && (price >= 20) && f(b.modified(20), c_sum-20, price-20)) {
        return true;
    }
    used.c20--;
    if (used.add(10) && b.c10 > 0 && (price >= 10) && f(b.modified(10), c_sum-10, price-10)) {
        return true;
    }
    used.c10--;
    if (used.add(5) && b.c5 > 0 && (price >= 5) && f(b.modified(5), c_sum-5, price-5)) {
        return true;
    }
    used.c5--;
    return false;
}

int main()
{
    Bank bank;
    ul c_sum=0; // coins
    ul price;

    ifstream in("calculation.in");
    in.sync_with_stdio(false);

    in >> bank.c5;
    c_sum+=bank.c5 * 5;
    in >> bank.c10;
    c_sum+=bank.c10 * 10;
    in >> bank.c20;
    c_sum+=bank.c20 * 20;
    in >> bank.c50;
    c_sum+=bank.c50 * 50;
    in >> price;

    in.close();

    ofstream out("calculation.out");
    out.sync_with_stdio(false);
    if ((price%10 != 0 && price%10 != 5) || price > c_sum ){
        out << -1;
    } else {
//        if (f(bank, c_sum, price)) {
//            out << used.c5 << " " << used.c10 << " " << used.c20 << " " << used.c50<< " " << used.c5 + used.c10 + used.c20 + used.c50;
//        } else {
//            out << -1;
//        }
        ul old_price = price;

        used.c50 = price/50;
        if (used.c50 > bank.c50) used.c50 = bank.c50;
        price -= used.c50 * 50;

        used.c20 = price/20;
        if (used.c20 > bank.c20) used.c20 = bank.c20;
        price -= used.c20 * 20;

        used.c10 = price/10;
        if (used.c10 > bank.c10) used.c10 = bank.c10;
        price -= used.c10 * 10;

        used.c5 = price/5;
        if (used.c5 > bank.c5) used.c5 = bank.c5;
        price -= used.c5 * 5;

        if (price != 0) out << -1;
        else out << used.c5 << " " << used.c10 << " " << used.c20 << " " << used.c50<< " " << used.c5 + used.c10 + used.c20 + used.c50;
    }
    out.close();

    return 0;
}
