/* GCC */
#include <iostream>
#include <fstream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>

using namespace std;
int n;
string s;
vector<int> best;

void show(vector<int> a){
    for(int i=0; i<a.size(); i++){
        cout<<a[i]<<' ';
    }
    cout<<endl;
}

void show(vector< vector<int> > a){
    for(int i=0; i<a.size(); i++){
        show(a[i]);
    }
    cout<<endl;
}

void readData(){
    freopen("strings.in", "r", stdin);

    scanf("%d", &n);
    getline(cin, s);
    getline(cin, s);
    best=vector<int>(n, -1);
    best[0]=0;

    fclose(stdin);
}

int getBest(int curr){
    if(best[curr]!=-1) return best[curr];
    for(int i=curr-1; i>=0; i--){
        best[curr]=max(best[curr], getBest(i)+(curr-i)*abs(s[curr]-s[i]));
    }
    return best[curr];
}

void fileOut(){
    freopen("strings.out", "w", stdout);

    //cout<<s<<endl;
    //cout<<getBest(n-1)<<endl;
    //show(best);
    for(int i=0; i<n-1; i++){
        for(int z=i+1; z<n; z++){
            best[z]=max(best[z], best[i]+(z-i)*abs(s[z]-s[i]));
        }
    }
    cout<<best[n-1]<<endl;

    fclose(stdin);
}

int main(){
    readData();
    fileOut();
    return 0;
}
