#include <iostream>
#include <fstream>
using namespace std;

typedef unsigned long ul;
typedef unsigned long long ull;

unsigned int delta(char a, char b) {
    int d = a - b;
    return d>=0 ? d : -d;
}

ull mScore = 0;
ul N;
string S;

void f(ul X, ull score) {
    if (X == N-1 && mScore < score) {
        mScore = score;
        return;
    }
    for (ul x=N-1; x>X; x--) {
//        for(int i=1; i<X; i++)cout << " ";
//        cout << "^";
//        for(int i=X+1; i<x; i++)cout << " ";
//        cout << "^ - delta(" <<S[x] << ", " << S[X] <<")="<<delta(S[x], S[X]) <<"; |x-X|="<<(x-X)<<endl;
        f(x, score + (x-X)*delta(S[x], S[X]));
    }
}

int main()
{
    ifstream in("strings.in");
    in.sync_with_stdio(false);
    in >> N;
    in >> S;
    in.close();

//    cout << S << endl;
    f(0, 0);

//    cout << delta('a','a');

    ofstream out("strings.out");
    out.sync_with_stdio(false);
    out << mScore;
    out.close();

    return 0;
}
