/* GCC */
#include <iostream>
#include <algorithm>
#include <stdio.h>

#define x first
#define y second

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

const int inf = 1000000007;
const int maxn = 1000100;

ll n;
string s;
ll mem[maxn];

ll dp(ll cur) {
    cout << cur << endl;
    if (cur == n-1)
        return 0;
    if (mem[cur])
        return mem[cur];
    ll res = 0;
    for (ll i = cur+1; i < n; i++)
        res = max(res, (i-cur)*abs(s[cur] - s[i]) + dp(i));
    return mem[cur] = res;
}

int main() {
    freopen("strings.in", "r", stdin);freopen("strings.out", "w", stdout);
    cin >> n >> s;
    if (n < 10e4) {
        fill(mem, mem+maxn, 0);
        cout << dp(0) << "\n";
    } else {
        ll res = 0;
        for (int i = 1; i < n; i++)
            res += abs(s[i] - s[i-1]);
        cout << res << "\n";
    }
    return 0;
}
