/* GCC */
#include <iostream>
#include <fstream>
#include <string>
#include <vector>
#include <math.h>

using namespace std;

int FindNext(string s, int i){
    int symb = s[i];
    int index = i;
    if(i + 1 == s.size() - 1){
        return i + 1;
    }
    for(int j = i + 1;j < s.size();j++){
        if(fabs(s[j] - symb) >= fabs(s[index] - symb)){
            index = j;
        }
    }
    return index;
}
int p = 0;
vector<vector<int> > Generate(vector<vector<int> > perms, int index, string s){
    vector<vector<int> > new_perms;
    for(int i = 0;i < perms.size();i++){
        if(perms[i][perms[i].size() - 1] == s.size() - 1){
            new_perms.push_back(perms[i]);
        }
        else{
            for(int j = perms[i][perms[i].size() - 1] + 1;j < s.size();j++){
                perms[i].push_back(j);
                new_perms.push_back(perms[i]);
                perms[i].pop_back();
            }
        }
    }
    vector<vector<int> > nperms;
    if(perms.size() != new_perms.size()){
        nperms = Generate(new_perms, 0, s);
        return nperms;
    }
    return new_perms;
}

int calc(vector<int> indexes, string s){
    if(indexes[indexes.size() - 1] != s.size() - 1){
        indexes.push_back(s.size() - 1);
    }
    int k = 0;
    for(int j = 0;j < indexes.size() - 1;j++){
        int i = indexes[j];
        int l = indexes[j + 1];
        k += (l - i) * fabs(s[i] - s[l]);
    }
    return k;
}

int main(){
    ifstream in;
    in.open("strings.in");
    string s;
    int n;
    in >> n >> s;
    int k = 0;
    if(n < 5000){
        vector<vector<int> > perm;
        for(int i = 0;i < s.size();i++){
            vector<int> p;
            p.push_back(i);
            perm.push_back(p);
        }
        vector<vector<int> > perms = Generate(perm, 0, s);
        int m = 0;
        for(int i = 0;i < perms.size();i++){
            int c = calc(perms[i], s);
            if(c > m){
                m = c;
            }
        }
        k = m;
    }
    else{
        for(int i = 0;i < s.size();){
            int l = FindNext(s, i);
            k += (l - i) * fabs(s[i] - s[l]);
            i = l;
            if(i == s.size() - 1){
                break;
            }
        }
    }
    ofstream out;
    out.open("strings.out");
    out << k << endl;
    out.close();
    return 0;
}
