/* GCC */
#include <stdio.h>
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

#define ll long long
#define FOR(i, n) for(int i=1; i<=n; i++)

#define MAXN 1000100
#define INF 4001000

int n;
int S[MAXN];
int DP[MAXN];

int mod(int a)
{
    if (a < 0) a = -a;
    return a;
}

int Dp(int x)
{
    if (DP[x] != -1) return DP[x];
    int res = 0, t;
    for (int i=(x-1); i>=1; i--){
        t = Dp(i) + (x-i)*mod(S[x]-S[i]);
        if (res < t) res = t;
    }
    DP[x] = res;
    return DP[x];
}

int main(void)
{
    freopen("strings.in", "r", stdin);
    freopen("strings.out", "w", stdout);

    cin >> n;
    char c;
    FOR(i, n){
        cin >> c;
        S[i] = c - 'a' + 1;
    }
//    FOR(i, n) cout << S[i] << endl;
/*
    int a = 'A';
    for(int i=0; i<53; i++) printf("%c ", a+i);
    cout << endl;
*/
    FOR(i, n+2) DP[i] = -1;
    DP[1] = 0;

    int res = Dp(n);
    cout << res << endl;
    return 0;
}
