/* GCC */

#include <cstdio>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;

int main(){
    freopen("robot.in", "r", stdin);
    freopen("robot.out", "w", stdout);

    int n,k;
    vector <int> Table, Len;

    scanf("%d%d", &n, &k);

    Table.resize(n);

    for (int i = 0; i<n; i++){
        scanf("%d", &Table[i]);
    }

    if (n <= k){
        printf("%d", n);
        return 0;
    }

    Table.resize(n*k);
    Len.assign(n*k, 1);

    for (int i = 1; i<k; i++){
        for (int j = 0; j<n; j++){
            Table[i*n+j] = Table[i*n-j-1];
        }
    }
/*
    for (int i = 0; i<n*k; i++){
        printf("%d ", Table[i]);
    }
    printf("\n");
*/
    Len[0] = 1; int max_len = 1;

    for (int i = 1; i<n*k; i++){
        if (i%n == 0){
            if (n - max_len <= k - i/n){
                printf("%d",n);
                return 0;
            }
        }
        for (int j = 0; j<i; j++){
            if (Table[j] < Table[i]) Len[i] = max(Len[i], Len[j]+1);
        }
        max_len = max(max_len, Len[i]);
    }

    printf("%d", max_len);

    return 0;
}
