#include <iostream>
#include <fstream>
#include <algorithm>

using namespace std;

int main()
{
    const int INF = 2147483647;
    ifstream in;
    ofstream out;
    in.open("robot.in");
    out.open("robot.out");

    int n, k;
    in >> n >> k;
    int shel[n];
    for (int i = 0; i < n; i++) {
        in >> shel[i];
    }
    int len = n*k;
    int shelves[len];
    for (int i = 0; i < k; i++) {
        if (i % 2 == 0) {
            for (int j = 0; j < n; j++) {
                shelves[i*n+j] = shel[j];
            }
        } else {
            for (int j = 0; j < n; j++) {
                shelves[i*n+j] = shel[n-1-j];
            }
        }
    }
    int dp[len+1];
    dp[0] = -INF;
    for (int i = 1; i<=len; i++) {
        dp[i] = INF;
    }

    for (int i=0; i<len; i++) {
        int j = upper_bound (dp, dp+len+1, shelves[i]) - dp;
        if (dp[j-1] < shelves[i] && shelves[i] < dp[j])
            dp[j] = shelves[i];
    }

    for (int i = len; i >= 0; i--) {
        if (dp[i] != INF) {
            out << i << endl;
            break;
        }
    }

    in.close();
    out.close();
    return 0;
}
