/* GCC */

#include <cstdio>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;

long long segments(vector <int> Lamp){
    int n; long long k = 0;
    n = Lamp.size();

    int i = 0, j = 0;

    while (j < n){
        if (Lamp[j] == 1) j++;
        else{
            k += pow(2,j-i);
            j++;
            i = j;
        }
    }
    if (Lamp[n-1] == 1) k+= pow(2,j-i);
    return k;
}

int main(){
    freopen("lanterns.in", "r", stdin);
    freopen("lanterns.out", "w", stdout);
    vector <int> Lamp;
    int n,q,l,r,a;
    char c;
    long long k;

    scanf("%d%d%c", &n, &q, &c);
    Lamp.resize(n);

    for (int i = 0; i<n; i++){
        scanf("%c", &c);
        if (c == '1') Lamp[i] = 1; else Lamp[i] = 0;
    }

    k = segments(Lamp);
    printf("%lld",k);

    for (int i = 0; i<q; i++){
        scanf("%d%d%d", &l, &r, &a);
        l--; r--;
        for (int j = l; j<=r; j++) Lamp[j] = a;
        k = segments(Lamp);
        printf("%lld",k);
    }

    return 0;
}
