/* GCC */
#include <iostream>
#include <fstream>
#include <cstdio>
#include <string>
#include <cmath>
#include <algorithm>

using namespace std;

/*int segs (string s) {
    int l = s.size();
    int fi = 0, se = 0,res = 0;
    s = s + "0";
    bool seg = false;
    for (int i = 0; i <= l; i++) {
        if (s[i] == '1' && !seg) {
            fi = i;
            seg = true;
        } else if (s[i] == '0' && seg) {
            se = i-1;
            seg = false;
            int delta = se-fi+1;
            res += delta*(delta+1)/2;
        }
    }
    return res;
}*/

int main()
{
    ifstream in;
    ofstream out;
    in.open("lanterns.in");
    out.open("lanterns.out");
    int n, q;
    in >> n >> q;
    string S;
    in >> S;
    S = S + "0"; n++;
    int segs[n][n];
    for (int i = 0; i < n; i++) {
        for(int j = 0; j < n; j++) {
            segs[i][j] = 0;
        }
    }

    int fi = 0, se = 0, res = 0;
    bool seg = false;
    for (int i = 0; i < n; i++) {
        if (S[i] == '1' && !seg) {
            fi = i;
            seg = true;
        } else if (S[i] == '0' && seg) {
            se = i-1;
            seg = false;
            for (int i = fi; i <= se; i++) {
                for (int j = i; j <= se; j++) {
                    segs[i][j] = 1;
                    res++;
                }
            }
        }
    }
    out << res << endl;

    for (int i = 0; i < q; i++) {
        int b, e, t;
        in >> b >> e >> t;
        b--, e--;
        string ins;
        if (t == 1) {
            ins = string(e-b+1, '1');
        } else {
            ins = string(e-b+1, '0');
        }
        S = S.substr(0, b) + ins + S.substr(e+1, n);
        for (int i = 0; i < n; i++) {
            if (S[i] == '1' && !seg) {
                    fi = i;
                    seg = true;
            } else if (S[i] == '0' && seg) {
                se = i-1;
                seg = false;
                for (int i = fi; i <= se; i++) {
                    for (int j = i; j <= se; j++) {
                        if (segs[i][j] == 0){
                            segs[i][j] = 1;
                            res++;
                        }
                    }
                }
            }
        }
        out << res << endl;
    }

    in.close();
    out.close();
    return 0;
}
