/* GCC */

#include <iostream>
#include <fstream>
using namespace std;

typedef struct activity {
    int st,en;
    int b;
};



int main() {

    ifstream fin;
    fin.open("lanterns.in");

    int n,q;



    fin>>n>>q;

    char l[n+1];


    fin>>l;

    activity act[q];

    for (int i=0; i<q; i++) {
        fin>>act[i].st>>act[i].en>>act[i].b;
    }


    fin.close();



    bool pair_[n][n];

    for (int i=0; i<n;i++) {
        for (int j=0; j<n;j++) {
            pair_[i][j]=0;
        }
    }


    int res=0;

    for (int i=0; i<n; i++) {
        if (l[i] == '1')
            {pair_[i][i]=1; res++;}
        else continue;
        for (int j=i+1; j<n;j++) {
            if (l[i] == '1' && l[j] == '1' && pair_[i][j-1])
                {pair_[i][j]=1; res++;}
        }
    }

    ofstream fout;
    fout.open("lanterns.out");
    fout<<res<<endl;
    for (int i=0; i<q; i++) {
        if (act[i].b==1) {
            for (int j = act[i].st-1, k=act[i].en; j<k;j++) {
                l[j]='1';
            }
        }
        else
            for (int j = act[i].st-1, k=act[i].en; j<k;j++) {
                l[j]='0';
            }
        for (int j=0; j<n; j++) {
            if (l[j] == '1' && !pair_[j][j])
                {pair_[j][j]=1; res++;}
            else if (l[j]=='0') {continue;}
            for (int k=j+1; k<n;k++) {
                if (l[j] == '1' && l[k] == '1' && !pair_[j][k] && pair_[j][k-1])
                    {pair_[j][k]=1; res++;}
            }
        }
        fout<<res<<endl;
    }

    fout.close();

    return 0;
}
