/* GCC */

#include <iostream>
#include <algorithm>
#include <cstdio>
#include <vector>
#include <map>
#include <set>

using namespace std;

/*        */

#define FilkinMaksim int main()
#define ALL(a) a.begin(),a.end()
#define f_in(s) freopen(s,"r",stdin)
#define f_out(s) freopen(s,"w",stdout)
#define endl '\n'
#define fast ios_base::sync_with_stdio(false);cin.tie(false);cout.tie(false)
#define X first
#define Y second

const int inf = 1e9;
const long long linf = 1e12;
const long long mod = 1e9 + 7;

typedef long long ll;
typedef long double ld;

string s;
map <int,set<int>> r;

int ans(int n)
{
    int res = 0;
    for (int i = 0; i < n; i++)
    {
        int j = i;
        while (j < n && s[j] == '1') j++;
        for (int k = i; k <= j; k++)
            for (int q = k + 1; q <= j; q++)
                r[k].insert(q);
    }
    for (int i = 0; i < n; i++)
        res += r[i].size();
    return res;
}

FilkinMaksim
{
    f_in("lanterns.in");
    f_out("lanterns.out");
    int q,n;
    scanf("%d%d",&n,&q);
    cin >> s;
    printf("%d\n",ans(n));
    while (q--)
    {
        int x,y,t;
        char z;
        scanf("%d%d%d",&x,&y,&t);
        x--;y--;
        if (t == 1) z = '1';
        else z = '0';
        for (int i = x; i <= y; i++)
            s[i] = z;
        printf("%d\n",ans(n));
    }
}
