/* GCC */
#include <iostream>
#include <cstdio>
#include <string>
#include <cmath>
#include <vector>
#include <set>
#include <iomanip>
#include <list>
#include <map>
#include <algorithm>

using namespace std;

int coins[] = {50, 20, 10, 5};
vector <int> amountOfCoins (4);
vector <int> coinsToPay (4, 0);
long long int needToPay;
long long int result = 0;

int main ()
{
	freopen("calculation.in", "r", stdin);
	freopen("calculation.out", "w", stdout);

	cin >> amountOfCoins[3] >> amountOfCoins[2] >> amountOfCoins[1] >> amountOfCoins[0]
	    >> needToPay;


	int nowPaing = 0;
	while(needToPay){
		if(needToPay < coins[nowPaing] || !amountOfCoins[nowPaing]){
			nowPaing++;
			if(nowPaing == 4) return 0;

			continue;
		}

		long long int localCoinsToPay = needToPay / coins[nowPaing];

		if(localCoinsToPay){
			if(amountOfCoins[nowPaing] < localCoinsToPay){
				localCoinsToPay = amountOfCoins[nowPaing];
			}

			needToPay -= localCoinsToPay * coins[nowPaing];
			amountOfCoins[nowPaing] -= localCoinsToPay;
			coinsToPay[nowPaing] += localCoinsToPay;
		}
	}

	for(int i = 3; i >= 0; i++)
		cout << coinsToPay[i] << " ";

	cout << result;

	return 0;
}
