/* GCC */
#include <bits/stdc++.h>

using namespace std;

#define ft first
#define sd second
#define pii pair<int, int>

typedef long long ll;

#define open(s) freopen(s".in", "r", stdin); freopen(s".out", "w", stdout);

int m5, m10, m20, m50, total;

int main(){
    open("calculation");

    cin >> m5 >> m10 >> m20 >> m50 >> total;

    if (m5 * 5 + m10 * 10 + m20 * 20 + m5 * 50 < total || (total % 5) != 0)
    {
        cout << -1 << "\n";
        return 0;
    }

    int ans[4] = {0};
    while (total > 0 && (m5 + m10 + m20 + m50) > 0)
    {
        while (m50 > 0 && total >= 50)
        {
            total -= 50;
            --m50;

            ++ans[3];
        }

        while (m20 > 0 && total >= 20)
        {
            total -= 20;
            --m20;

            ++ans[2];
        }

        while (m10 > 0 && total >= 10)
        {
            total -= 10;
            --m10;

            ++ans[1];
        }

        while (m5 > 0 && total >= 5)
        {
            total -= 5;
            --m5;

            ++ans[0];
        }
    }

    if (total > 0)
        cout << -1 << "\n";
    else
    {
        cout << ans[0] << " " << ans[1] << " " << ans[2] << " " << ans[3] << " " << ans[0] + ans[1] + ans[2] + ans[3] << "\n";
    }

    return 0;
}

