/* GCC */

#include <fstream>
#include <iostream>

using namespace std;

int main()
{
    ifstream in("calculation.in");
    ofstream out("calculation.out");

    unsigned long m5, m10, m20, m50, price;
    in >> m5 >> m10 >> m20 >> m50 >> price;

    if (price % 5 != 0 || price < 0)
    {
        out << -1;
        return 0;
    }

    unsigned long a5, a10, a20, a50;
    a5 = a10 = a20 = a50 = 0;
    a50 = min(price / 50, m50);
    price -= a50 * 50;
    a20 = min(price / 20, m20);
    price -= a20 * 20;
    a10 = min(price / 10, m10);
    price -= a10 * 10;
    a5 = min(price / 5, m5);
    price -= a5 * 5;

    if (price != 0)
    {
        out << -1;
    }
    else
    {
        out << a5 << " " << a10 << " " << a20 << " " << a50 << " " << (a5 + a10 + a20 + a50);
    }
    return 0;
}
