/* GCC */
#include <bits/stdc++.h>

using namespace std;

#define ft first
#define sd second
#define pii pair<int, int>

typedef long long ll;

#define open(s) freopen(s".in", "r", stdin); freopen(s".out", "w", stdout);

int m5, m10, m20, m50, total;

struct ch {
    int m5, m10, m20, m50;
};

int main(){
    open("calculation");

    cin >> m5 >> m10 >> m20 >> m50 >> total;

    if (m5 * 5 + m10 * 10 + m20 * 20 + m5 * 50 < total || (total % 5) != 0)
    {
        cout << -1 << "\n";
        return 0;
    }

    ll dp[total + 1] = {0};
    ch checker[total + 1];
    if (m5 > 0)
    {
        dp[5] = 1;
        checker[5] = {m5 - 1, m10, m20, m50};
    }
    if (m10 > 0)
    {
        dp[10] = 1;
        checker[10] = {m5, m10 - 1, m20, m50};
    }
    if (m20 > 0)
    {
        dp[20] = 1;
        checker[20] = {m5, m10, m20 - 1, m50};
    }
    if (m50 > 0)
    {
        dp[50] = 1;
        checker[50] = {m5, m10, m20, m50 - 1};
    }

    for (int i = 15; i <= total; i+=5)
    {
        if(dp[i] == 0)
        {
            if (dp[i - 5] > 0 && checker[i - 5].m5 > 0)
            {
                dp[i] = dp[i - 5];
                checker[i] = checker[i - 5];
                --checker[i].m5;
            }
            if (dp[i - 10] > 0 && checker[i - 10].m10 > 0)
            {
                if (dp[i] == 0)
                {
                    dp[i] = dp[i - 10];
                    checker[i] = checker[i - 10];
                    --checker[i].m10;
                }
                else
                {
                    if (dp[i - 10] < dp[i])
                    {
                        dp[i] = dp[i - 10];
                        checker[i] = checker[i - 10];
                        --checker[i].m10;
                    }
                }
            }
            if (dp[i - 20] > 0 && checker[i - 20].m20 > 0)
            {
                if (dp[i] == 0)
                {
                    dp[i] = dp[i - 20];
                    checker[i] = checker[i - 20];
                    --checker[i].m20;
                }
                else
                {
                    if (dp[i - 20] < dp[i])
                    {
                        dp[i] = dp[i - 20];
                        checker[i] = checker[i - 20];
                        --checker[i].m20;
                    }
                }
            }
            if (dp[i - 50] > 0 && checker[i - 50].m50 > 0)
            {
                if (dp[i] == 0)
                {
                    dp[i] = dp[i - 50];
                    checker[i] = checker[i - 50];
                    --checker[i].m50;
                }
                else
                {
                    if (dp[i - 50] < dp[i])
                    {
                        dp[i] = dp[i - 50];
                        checker[i] = checker[i - 50];
                        --checker[i].m50;
                    }
                }
            }

            if (dp[i] != 0)
                ++dp[i];
        }
    }

    ch temp = checker[total];

    cout << m5 - temp.m5 << " " << m10 - temp.m10 << " " << m20 - temp.m20 << " " << m50 - temp.m50 <<  " " << dp[total] << "\n";

    return 0;
}

