/* GCC */

#include <iostream>
#include <algorithm>
#include <cstdio>
#include <vector>
#include <map>
#include <set>

using namespace std;

/*

       
2 0 5 1 100
   
1:2 0 2 1 5
2:0 0 5 0 5
      ...

*/

#define FilkinMaksim int main()
#define ALL(a) a.begin(),a.end()
#define f_in(s) freopen(s,"r",stdin)
#define f_out(s) freopen(s,"w",stdout)
#define endl '\n'
#define fast ios_base::sync_with_stdio(false);cin.tie(false);cout.tie(false)
#define X first
#define Y second

const int inf = 1e9;
const long long linf = 1e12;
const long long mod = 1e9 + 7;

typedef long long ll;
typedef long double ld;


unsigned long long bin(unsigned long long kol, unsigned long long x, unsigned long long s)
{
    unsigned long long l = 0, r = kol;
    while (r - l > 1)
    {
        unsigned long long mid = (r + l) / 2;
        if (mid * x <= s) l = mid;
        else r = mid;
    }
    if (r * x <= s) return r;
    return l;
}

FilkinMaksim
{
    f_in("calculation.in");
    f_out("calculation.out");
    unsigned long long s,a,b,c,d;
    cin >> a >> b >> c >> d >> s;
    unsigned long long ans[4];
    ans[0] = ans[1] = ans[2] = ans[3] = 0;
    if (s % 5 != 0)
    {
        cout << -1 << endl;
        return 0;
    }
    ans[3] = bin(d,50,s);
    s -= ans[3] * 50;
    ans[2] = bin(c,20,s);
    s -= ans[2] * 20;
    ans[1] = bin(b,10,s);
    s -= ans[1] * 10;
    ans[0] = bin(a,5,s);
    s -= ans[0] * 5;

    if (s)
    {
        cout << -1 << endl;
        return 0;
    }
    cout << ans[0] << ' ' << ans[1] << ' ' << ans[2] << ' ' << ans[3] << ' ' << ans[0] + ans[1] + ans[2] + ans[3] << endl;
}
