/* GCC */
#include <stdio.h>
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

#define ll long long
#define FOR(i, n) for(int i=0; i<n; i++)

#define MAXN 10000100
#define INF 4001000

struct Money
{
    int k5, k10, k20, k50, n;
    int used;
};

//int k5, k10, k20, k50, n;
//int res5, res10, res20, res50, res;
Money N, RES;

Money DP[MAXN];

Money MinMoney(Money X, Money Y)
{
    if (X.used < Y.used) return X;
    else return Y;
}

Money Dp(Money X)
{
//    cout << "Here" << endl;

//    if (DP[X.n].used != -1) return DP[X.n];

    Money A=X, B=X, C=X, D=X;
    if (X.n == 0) return X;
    if (X.n < 5){
        A.used = INF;
        return A;
    }
    if (X.n < 10){
        if (X.k5 == 0){
            A.used = INF;
            return A;
        }
        A.n -= 5; A.k5--; A.used++;
        return Dp(A);
    }
    if (X.n < 20){
        if (X.k10 == 0){
            if (X.k5 == 0){
                A.used = INF;
                return A;
            }
            A.n -= 5; A.k5--; A.used++;
            return Dp(A);
        }
        if (X.k5 == 0){
            B.n -= 10; B.k10--; B.used++;
            return Dp(B);
        }
        A.n -= 5; A.k5--; A.used++;
        B.n -= 10; B.k10--; B.used++;
        return MinMoney(Dp(A), Dp(B));
    }
    if (X.n < 50){
        if (X.k20 == 0){
            if (X.k10 == 0){
                if (X.k5 == 0){
                    A.used = INF;
                    return A;
                }
                A.n -= 5; A.k5--; A.used++;
                return Dp(A);
            }
            if (X.k5 == 0){
                B.n -= 10; B.k10--; B.used++;
                return Dp(B);
            }
            A.n -= 5; A.k5--; A.used++;
            B.n -= 10; B.k10--; B.used++;
            return MinMoney(Dp(A), Dp(B));
        }
        if (X.k10 == 0){
            if (X.k5 == 0){
                C.n -= 20; C.k20--; C.used++;
                return Dp(C);
            }
            A.n -= 5; A.k5--; A.used++;
            C.n -= 20; C.k20--; C.used++;
            return MinMoney(Dp(A), Dp(C));
        }
        if (X.k5 == 0){
            B.n -= 10; B.k10--; B.used++;
            C.n -= 20; C.k20--; C.used++;
            return MinMoney(Dp(B), Dp(C));
        }
        A.n -= 5; A.k5--; A.used++;
        B.n -= 10; B.k10--; B.used++;
        C.n -= 20; C.k20--; C.used++;
        return MinMoney( MinMoney(Dp(A), Dp(B)), Dp(C));
    }
    if (X.k50 == 0){
        if (X.k20 == 0){
            if (X.k10 == 0){
                if (X.k5 == 0){
                    A.used = INF;
                    return A;
                }
                A.n -= 5; A.k5--; A.used++;
                return Dp(A);
            }
            if (X.k5 == 0){
                B.n -= 10; B.k10--; B.used++;
                return MinMoney(Dp(A), Dp(B));
            }
            A.n -= 5; A.k5--; A.used++;
            B.n -= 10; B.k10--; B.used++;
            return MinMoney(Dp(A), Dp(B));
        }
        if (X.k10 == 0){
            if (X.k5 == 0){
                C.n -= 20; C.k20--; C.used++;
                return Dp(C);
            }
            A.n -= 5; A.k5--; A.used++;
            C.n -= 20; C.k20--; C.used++;
            return MinMoney(Dp(A), Dp(C));
        }
        if (X.k5 == 0){
            B.n -= 10; B.k10--; B.used++;
            C.n -= 20; C.k20--; C.used++;
            return MinMoney(Dp(B), Dp(C));
        }
        A.n -= 5; A.k5--; A.used++;
        B.n -= 10; B.k10--; B.used++;
        C.n -= 20; C.k20--; C.used++;
        return MinMoney( MinMoney(Dp(A), Dp(B)), Dp(C));
    }
    if (X.k20 == 0){
        if (X.k10 == 0){
            if (X.k5 == 0){
                D.n -= 50; D.k50--; D.used++;
                return Dp(D);
            }
            A.n -= 5; A.k5--; A.used++;
            D.n -= 50; D.k50--; D.used++;
            return MinMoney(Dp(A), Dp(D));
        }
        if (X.k5 == 0){
            D.n -= 50; D.k50--; D.used++;
            B.n -= 10; B.k10--; B.used++;
            return MinMoney(Dp(D), Dp(B));
        }
        A.n -= 5; A.k5--; A.used++;
        B.n -= 10; B.k10--; B.used++;
        return MinMoney(Dp(A), Dp(B));
    }
    if (X.k10 == 0){
        if (X.k5 == 0){
            D.n -= 50; D.k50--; D.used++;
            C.n -= 20; C.k20--; C.used++;
            return MinMoney(Dp(C), Dp(D));
        }
        A.n -= 5; A.k5--; A.used++;
        C.n -= 20; C.k20--; C.used++;
        D.n -= 50; D.k50--; D.used++;
        return MinMoney( MinMoney(Dp(A), Dp(C)), Dp(D));
    }
    if (X.k5 == 0){
        B.n -= 10; B.k10--; B.used++;
        C.n -= 20; C.k20--; C.used++;
        D.n -= 50; D.k50--; D.used++;
        return MinMoney( MinMoney(Dp(B), Dp(C)), Dp(D));
    }
    A.n -= 5; A.k5--; A.used++;
    B.n -= 10; B.k10--; B.used++;
    C.n -= 20; C.k20--; C.used++;
    D.n -= 50; D.k50--; D.used++;
    return MinMoney( MinMoney( MinMoney(Dp(A), Dp(B)), Dp(C)), Dp(D));
}

int main(void)
{
    freopen("calculation.in", "r", stdin);
    freopen("calculation.out", "w", stdout);

    cin >> N.k5 >> N.k10 >> N.k20 >> N.k50;
    cin >> N.n;

//    FOR(i, N.n+2) DP[i].used = -1;
//    DP[0].used = 0;

    if ((N.k5 ==0)&&(N.k10==0)&&(N.k20==0)){
        if ((N.n % 50) == 0){
            if ((N.n / 50) <= N.k50){
                cout << "0 ";
                cout << "0 ";
                cout << "0 ";
                cout << (N.n / 50) << " ";
                cout << (N.n / 50) << endl;
                return 0;
            }
        }
        cout << "-1" << endl;
        return 0;
    }
    if ((N.k5 ==0)&&(N.k10==0)&&(N.k50==0)){
        if ((N.n % 20) == 0){
            if ((N.n / 20) <= N.k20){
                cout << "0 ";
                cout << "0 ";
                cout << (N.n / 20) << " ";
                cout << "0 ";
                cout << (N.n / 20) << endl;
                return 0;
            }
        }
        cout << "-1" << endl;
        return 0;
    }
    if ((N.k5 ==0)&&(N.k20==0)&&(N.k50==0)){
        if ((N.n % 10) == 0){
            if ((N.n / 10) <= N.k10){
                cout << "0 ";
                cout << (N.n / 10) << " ";
                cout << "0 ";
                cout << "0 ";
                cout << (N.n / 10) << endl;
                return 0;
            }
        }
        cout << "-1" << endl;
        return 0;
    }
    if ((N.k10==0)&&(N.k20==0)&&(N.k50==0)){
        if ((N.n % 5) == 0){
            if ((N.n / 5) <= N.k5){
                cout << (N.n / 5) << " ";
                cout << "0 ";
                cout << "0 ";
                cout << "0 ";
                cout << (N.n / 5) << endl;
                return 0;
            }
        }
        cout << "-1" << endl;
        return 0;
    }


    N.used = 0;
    RES = Dp(N);

    if (RES.used == INF){ cout << "-1" << endl; return 0; }

    cout << N.k5-RES.k5 << " ";
    cout << N.k10-RES.k10 << " ";
    cout << N.k20-RES.k20 << " ";
    cout << N.k50-RES.k50 << " ";
    cout << RES.used << endl;

    return 0;
}
