/* GCC */
#include <iostream>
#include <fstream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>

using namespace std;
int n;
string s;
vector<int> best;

void show(vector<int> a){
    for(int i=0; i<a.size(); i++){
        cout<<a[i]<<' ';
    }
    cout<<endl;
}

void show(vector< vector<int> > a){
    for(int i=0; i<a.size(); i++){
        show(a[i]);
    }
    cout<<endl;
}

void readData(){
    freopen("strings.in", "r", stdin);

    scanf("%d", &n);
    getline(cin, s);
    getline(cin, s);
    best=vector<int>(n, -1);
    best[0]=0;

    fclose(stdin);
}

int getBest(int curr){
    if(best[curr]!=-1) return best[curr];
    int currMax=0;
    for(int i=curr-1; i>=0; i--){
        currMax=max(currMax, getBest(i)+(curr-i)*abs(s[curr]-s[i]));
    }
    best[curr]=currMax;
    return currMax;
}

void fileOut(){
    freopen("strings.out", "w", stdout);

    //cout<<s<<endl;
    cout<<getBest(n-1)<<endl;
    //show(best);

    fclose(stdin);
}

int main(){
    readData();
    fileOut();
    return 0;
}
