/* GCC */

#include <iostream>
#include <algorithm>
#include <cstdio>
#include <vector>
#include <map>
#include <set>

using namespace std;

#define FilkinMaksim int main()
#define ALL(a) a.begin(),a.end()
#define f_in(s) freopen(s,"r",stdin)
#define f_out(s) freopen(s,"w",stdout)
#define endl '\n'
#define fast ios_base::sync_with_stdio(false);cin.tie(false);cout.tie(false)
#define X first
#define Y second

const int inf = 1e9;
const long long linf = 1e12;
const long long mod = 1e9 + 7;

typedef long long ll;
typedef long double ld;

FilkinMaksim
{
    f_in("strings.in");
    f_out("strings.out");
    int n;
    cin >> n;
    string s;
    cin >> s;
    bool f = false;
    for (int i = 0; i < n && !f; i++)
    {
        if (s[i] > 'b') f = true;
    }
    if (!f)
    {
        int i = n - 1;
        while (s[i] == s[0] && i > -1) i--;
        if (i == -1) return cout << 0 << endl , 0;
        return cout << n << endl, 0;
    }
    vector <int> dp;
    dp.assign(n,0);
    for (int i = 1; i < n; i++)
    {
        for (int j = 0; j < i; j++)
            dp[i] = max(dp[i],dp[j] + (i-j) * abs(int(s[i]) - int(s[j])));
    }
    cout << dp[n - 1] << endl;
}
