/* GCC */
#include <fstream>
#include <cstdio>
#include <string>
#include <cmath>
#include <algorithm>

using namespace std;

int main()
{
    ifstream in;
    ofstream out;
    in.open("strings.in");
    out.open("strings.out");
    int len;
    bool onlyab = true, a = false, b = false;
    in >> len;
    string S;
    in >> S;
    int max_res[len];
    for (int i = 0; i < len; i++) {
        if (S[i] != 'a' && S[i] != 'b') {
            onlyab = false;
            break;
        } else if (S[i] == 'a') {
            a = true;
        } else {
            b = true;
        }
    }
    if (onlyab && a && b) {
        out << len-1 << endl;
        return 0;
    } else if (onlyab) {
        out << 0 << endl;
        return 0;
    }
    max_res[0] = 0;
    for (int i = 1; i < len; i++) {
        int cur_max = 0;
        for (int j = max(0, i-1000); j < i; j++) {
            int cur = abs(S[i]-S[j]) * (i-j) + max_res[j];
            if (cur > cur_max) cur_max = cur;
        }
        max_res[i] = cur_max;
    }
    out << max_res[len-1] << endl;
    in.close();
    out.close();
    return 0;
}
