""" Python 3 """

inp = open("strings.in").readlines()
out = open("strings.out", 'w')

row_length = int(inp[0])
row = list(inp[1])

# no choise, lol. In Python, characters can't be substracted.
alphabet = {
	"a": 0,
	"b": 1,
	"c": 2,
	"d": 3,
	"e": 4,
	"f": 5,
	"g": 6,
	"h": 7,
	"i": 8,
	"j": 9,
	"k": 10,
	"l": 11,
	"m": 12,
	"n": 13,
	"o": 14,
	"p": 15,
	"q": 16,
	"r": 17,
	"s": 18,
	"t": 19,
	"u": 20,
	"v": 21,
	"w": 22,
	"x": 23,
	"y": 24,
	"z": 25,
}

cache = {}

def move_score(from_i, to_i):
	return (to_i - from_i) * abs(alphabet[row[to_i]] - alphabet[row[from_i]])

def solve(index):
	if index == len(row):
		return 0
	elif index == len(row) - 1:
		return 0
	elif index in cache:
		return cache[index]
	else:
		best_score = 0
		for i in range(index+1, len(row)):
			t_score = solve(i) + move_score(index, i)
			if t_score > best_score:
				best_score = t_score
		cache[index] = best_score
		return best_score

out.write(str(solve(0)) + '\n')
out.close()