#include <iostream>
#include <fstream>
#include <cmath>
#include <string>
#include <vector>
using namespace std;

ifstream in("strings.in");
ofstream out("strings.out");

const string alph = "abcdefghijklmnopqrstuvwxyz";

int indexOf(char _c){
    for(int i = 0; i < 26; i++){
        if(alph[i] == _c){
            return i;
        }
    }
}

long long n;
string s;
int main()
{
    in >> n >> s;
    long long arr[n];
    long long positions[26];
    for(int i = 0; i < n; i++){
        arr[i] = 0;
    }
    for(int i = 0; i < 26; i++){
        positions[i] = -1;
    }
    positions[indexOf(s[n-1])] = 0;
    for(int i = 1; i < n; i++){
        for(int j = 0; j < 26; j++){
            if(positions[j] != -1){
                arr[i] = max(arr[i], (i - positions[j])*(abs(indexOf(s[n - i - 1]) - j)) + arr[positions[j]] );
            }
        }
        positions[indexOf(s[n - i - 1])] = i;
    }
    out << arr[n-1] << endl;
    return 0;
}
