/* GCC */
#include <iostream>
#include <fstream>
#include <vector>
#include <cmath>
#include <queue>

struct Vertex{
   short id = 0;
   short weigth = 0;
   short from = 0;
};

using namespace std;

int main(){
    ifstream input("strings.in");
    ofstream output("strings.out");
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    short n;
    short nn[100000];
    vector<Vertex> mass[100000];
    queue<Vertex> the_next;
    input >> n;
    for(int i = 0; i < n; i++){
        char temp;
        input >> temp;
        nn[i] = (short)temp - 96;
    }
    for(int i = 0; i < n-1; i++){
        for(int j = n-1; j >= (1+i); j--){
            Vertex a; a.id = j; a.weigth = (j-i)*abs(nn[i]-nn[j]); a.from = i;
            mass[i].push_back(a);
        }
        nn[i] = 0;
    }
    nn[n-1] = 0;

    for(int i = 0; i < n-1; i++)
        the_next.push(mass[0][i]);

    while(the_next.size() != 0){
       Vertex a = the_next.front();
       the_next.pop();
       if(a.weigth+nn[a.from] > nn[a.id])
          nn[a.id] = a.weigth+nn[a.from];
       for(int i = 0; i < mass[a.id].size(); i++){
          the_next.push(mass[a.id][i]);
       }
    }

    output << nn[n-1] << endl;
    return 0;
}
