import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;

import com.sun.javafx.Utils;

public class robot {

	public static void main(String[] args) throws IOException {
		BufferedReader reader = new BufferedReader(new FileReader("robot.in"));
		FileWriter writer = new FileWriter("robot.out");

		String[] input = reader.readLine().split(" ");
		int shelvesTotal = Integer.parseInt(input[0]);
		int passes = Integer.parseInt(input[1]);

		input = reader.readLine().split(" ");
		int[] shelves = new int[shelvesTotal];
		for (int i = 0; i < shelvesTotal; i++) {
			shelves[i] = Integer.parseInt(input[i]);
		}
		passShelf(0, false, 1, shelves, 1, passes, 0);

		writer.write(Integer.toString(bestResult));
		writer.write(System.lineSeparator());
		writer.close();
		reader.close();
	}

	static int bestResult = 0;

	static void passShelf(int currentShelf, boolean backwards, int currentBox,
			int[] shelves, int passes, int maxPasses, int currentResult) {
		if (shelves[currentShelf] == currentBox) {
//			System.out.println("putting right now " + currentShelf);
			currentBox++;
			currentResult++;
			if (currentResult > bestResult)
				bestResult = currentResult;
//			System.out.println("result now: " + currentResult);
			if (currentBox == shelves.length)
				return; // this was the last box
			shelves[currentShelf] = -1;

			int nextShelf = backwards ? (currentShelf - 1) : (currentShelf + 1);
			if (nextShelf < 0 || nextShelf >= shelves.length) {
				if (passes == maxPasses)
					return;
				nextShelf = Utils.clamp(0, nextShelf, shelves.length - 1);
				passShelf(nextShelf, !backwards, currentBox, shelves,
						passes + 1, maxPasses, currentResult);
			} else {
				passShelf(nextShelf, backwards, currentBox, shelves, passes,
						maxPasses, currentResult);
			}
			return;
		}
		// skip shelf
//		System.out.println("skipping shelf " + currentShelf);
		int nextShelf = backwards ? (currentShelf - 1) : (currentShelf + 1);
		if (nextShelf < 0 || nextShelf >= shelves.length) {
			if (passes != maxPasses) {
				nextShelf = Utils.clamp(0, nextShelf, shelves.length - 1);
				passShelf(nextShelf, !backwards, currentBox, shelves,
						passes + 1, maxPasses, currentResult);
			}
		} else {
			passShelf(nextShelf, backwards, currentBox, shelves, passes,
					maxPasses, currentResult);
		}

		// don't skip
//		System.out.println("not skipping shelf " + currentShelf);
		if (shelves[currentShelf] != -1 && shelves[currentShelf] >= currentBox) {
			while (currentBox < shelves[currentShelf]) {
				currentBox++;
			}
			currentBox++;
			currentResult++;
//			System.out.println("result now: " + currentResult);
			if (currentResult > bestResult)
				bestResult = currentResult;
			if (currentBox == shelves.length)
				return; // this was the last box
			shelves[currentShelf] = -1;

			nextShelf = backwards ? (currentShelf - 1) : (currentShelf + 1);
			if (nextShelf < 0 || nextShelf >= shelves.length) {
				if (passes == maxPasses)
					return;
				nextShelf = Utils.clamp(0, nextShelf, shelves.length - 1);
				passShelf(nextShelf, !backwards, currentBox, shelves,
						passes + 1, maxPasses, currentResult);
			} else {
				passShelf(nextShelf, backwards, currentBox, shelves, passes,
						maxPasses, currentResult);
			}
		}
	}
}
